#ifndef TYPEH
#define TYPEH

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//===================================================================
// Ǝ^`
//===================================================================
namespace type { // start namespace type

  
  /*=================================================================
  ݂̃󋵂mF
  =================================================================*/
  const unsigned long long &current_memory();
  
  /*=================================================================
  new / deleteɃvsNX
  =================================================================*/
  class mem_base {


  public:
    
    //---------------------------------------------------------------
    // RXgN^
    //---------------------------------------------------------------
    mem_base();
    

    //---------------------------------------------------------------
    // m
    //---------------------------------------------------------------
    void *operator new(size_t t);    
    void *operator new[](size_t t);
    

    //---------------------------------------------------------------
    // 
    //---------------------------------------------------------------
    void operator delete(void *p);
    void operator delete[](void *p);

  }; // end class mem_base
  
  /*=================================================================   
  Ǝ^`
  =================================================================*/
  template <class T> class decl final : public mem_base {
    T value;
  public:
    decl(const T &t) : value(t){}
    decl(const decl &d) : value(d.value){}
    decl() : value(0){}

    const T operator+(const decl &d) const { return value + d.value; }
    const T operator-(const decl &d) const { return value - d.value; }
    const T operator*(const decl &d) const { return value * d.value; }
    const T operator/(const decl &d) const { return value / d.value; }    
    const T operator+(const T t) const { return value + t; }
    const T operator-(const T t) const { return value - t; }
    const T operator*(const T t) const { return value * t; }
    const T operator/(const T t) const { return value / t; }    
    const T operator+=(const decl &d) { return value += d.value; }
    const T operator-=(const decl &d) { return value -= d.value; }
    const T operator*=(const decl &d) { return value *= d.value; }
    const T operator/=(const decl &d) { return value /= d.value; }
    const T operator+=(const T t) { return value += t; }
    const T operator-=(const T t) { return value -= t; }
    const T operator*=(const T t) { return value *= t; }
    const T operator/=(const T t) { return value /= t; }    
    const T operator++(int i) { return value += 1; }
    const T operator++() { return value += 1; }
    const T operator--(int i) { return value -= 1; }
    const T operator--() { return value -= 1; }
    const T &operator()() const { return value; }
    void operator=(const decl &d) { value = d.value; }
    bool operator==(const T t) { return value == t; }
    bool operator==(const decl &d) { return value == d.value; }
    bool operator!=(const T t) { return value != t; }
    bool operator!=(const decl &d) { return value != d.value; }
  }; // end class decl


  /*=================================================================   
  fXgN^ŎIɕϐJCX^X̍쐬NX
  ̃NX͌pȂ
  =================================================================*/
  template <class T> class mem final : public mem_base {


  private:


    T *val;


  public:

    
    //---------------------------------------------------------------
    // RXgN^
    //---------------------------------------------------------------
    mem() : val(new T) , mem_base()
    {
    }
    mem(const T &v) : val(new T), mem_base()
    {
      *val = v;
    }
    mem(const mem &v) : val(new T), mem_base()
    {
      *val = v.get();
    }
    
    //---------------------------------------------------------------
    // fXgN^    
    //---------------------------------------------------------------
    ~mem(){ if(val) { delete val; val = NULL; } }

    
    //---------------------------------------------------------------
    // ƍ폜
    //---------------------------------------------------------------
    void destroy() { if(val) { delete val; val = NULL; } }
    void gen(const T &v){ if( ! val) { val = new T; *val = v; } }

    
    //---------------------------------------------------------------
    // 擾
    //---------------------------------------------------------------
    const T &get() const { return *val; }
    T &get() { return *val; }
    

    //---------------------------------------------------------------
    // 
    //---------------------------------------------------------------
    void operator=(const T &v) { *val = v; }
    void operator=(const mem &v) { *val = v.get(); }

  }; // end class mem



  /*=================================================================
  deque
  push pop͒x̂Œ
  =================================================================*/
  template<class T> class deque : public mem_base {
  

  protected:


    T *v;
    unsigned long num;


  public:

    //---------------------------------------------------------------
    // RXgN^
    //---------------------------------------------------------------
    deque() : v(NULL) , num(0) {}
    deque(const unsigned long size_) : 
    v(new T[size_]) ,
    num(size_)
    {
      // ftHgRXgN^ŏ
      for(unsigned int i = 0; i < size_; i++) v[i] = T();
    }
    deque(const unsigned long size_, const T &t) :
    v(new T[size_]) , 
    num(size_)
    {
      // lŏ
      for(unsigned int i = 0; i < size_; i++) v[i] = t;
    }
    deque(const deque &v_) :
    v(new T[v_.num]) ,
    num(v_.num)
    {
      // Rs[RXgN^
      for(unsigned int i = 0; i < num; i++) {
        T t = v_[i];
        v[i] = t;
      }
    }
    

    //---------------------------------------------------------------
    // fXgN^
    //---------------------------------------------------------------
    virtual ~deque() { clear(); }


    /*---------------------------------------------------------------
    Zq
    ---------------------------------------------------------------*/
    void operator=(const deque &v_) {
      clear();
      resize(v_.size());
      for(unsigned int i = 0; i < num; i++) {
        T t = v_[i];
        v[i] = t;
      }
    }
    

    //---------------------------------------------------------------
    // J
    //---------------------------------------------------------------
    void clear() { 
      if(v) {
        delete[] v; 
        v = NULL;
      } 
      num = 0;
    }
    

    //---------------------------------------------------------------
    // ݂̗vfԂ
    //---------------------------------------------------------------
    const unsigned long size() const { return num; }

    
    //---------------------------------------------------------------
    // ANZXZq
    //---------------------------------------------------------------
    const T &operator[](const unsigned long i) const { 
      if( ! v || i >= num) { 
        puts("out of array"); 
        exit(EXIT_FAILURE);
      }
      return v[i];
    }
    T &operator[](const unsigned long i) { 
      if( ! v || i >= num) {
        puts("out of array"); 
        exit(EXIT_FAILURE);
      }
      return v[i]; 
    }


    /*---------------------------------------------------------------
    zTCY
    ---------------------------------------------------------------*/
    void resize(const unsigned long i) {

      /*
      LW
      */
      T *tmp = new T[i];
      for(unsigned int j = 0; j < i; j++) tmp[j] = T();

      /*
      k
      */
      if(num > i && v) 
        for(unsigned int j = 0; j < i; j++) tmp[j] = v[j];

      /*
      L
      */
      else if(v) 
        for(unsigned int j = 0; j < num; j++) tmp[j] = v[j];

      /*
      Â̈J
      */
      clear();

      /*
      vfČvZ
      */
      num = i;

      v = tmp;
      tmp = NULL;
    }


    /*---------------------------------------------------------------
    push pop
    ---------------------------------------------------------------*/
    void push_back(const T &t) {
      resize(num + 1);
      v[num - 1] = t;
    }
    void pop_back() { resize(num - 1); }


    /*---------------------------------------------------------------
    push
    ---------------------------------------------------------------*/
    void push_front(const T &t) {

      /*
      vf𑝂₵zwlRs[
      */
      T *tmp = new T[num + 1];
      int a = num;

      /*
      push
      */
      tmp[0] = t;

      /*
      copy
      */
      if(v) for(unsigned int j = 1; j < num; j++) tmp[j] = v[j - 1];

      /*
      Â̈J
      */
      clear();

      /*
      vfČvZ
      */
      num = ++a;

      v = tmp;
      tmp = NULL;
    }


    /*---------------------------------------------------------------
    pop
    ---------------------------------------------------------------*/
    void pop_front() {

      /*
      k
      */
      T *tmp = new T[num - 1];
      int a = num;

      /*
      copy
      */
      if(v) 
        for(unsigned int j = 0; j < num - 1; j++) tmp[j] = v[j + 1];

      /*
      Â̈J
      */
      clear();

      /*
      vfČvZ
      */
      num = --a;

      v = tmp;
      tmp = NULL;
    }

  }; // end class deque

  
  /*=================================================================
  string
  =================================================================*/
  class string final : public deque<type::decl<char> > {


  public:

    
    //---------------------------------------------------------------
    // RXgN^
    //---------------------------------------------------------------
    string() : deque<type::decl<char> >() {}
    string(const unsigned long size) : deque<type::decl<char> >() {
      resize(size);
      memset(&v[0], 0, size);
    }
    string(const char *str) : deque<type::decl<char> >() {
      resize(strlen(str) + 1);
      memcpy(&v[0], str, num);
    }
    string(const string &s) : deque<type::decl<char> >() {
      resize(s.size());
      memcpy(&v[0], &s[0], num);
    }
    
    //---------------------------------------------------------------
    // fXgN^
    //---------------------------------------------------------------
    virtual ~string() {}

    
    //---------------------------------------------------------------
    // Zq
    //---------------------------------------------------------------
    const bool operator==(const string &s) const {
      return strcmp((const char *)&v[0], 
        (const char*)&s.v[0]) == 0 ? true : false;
    }
    const bool operator!=(const string &s) const {
      return ! operator==(s);
    }
    void operator+=(const string &s) {
      unsigned long sz = num - 1;
      resize(sz + s.size());
      memcpy(&v[sz], &s[0], s.size());
    }
    void operator+=(const char *s) {
      unsigned long sz = num - 1;
      resize(sz + strlen(s) + 1);
      memcpy(&v[sz], s, strlen(s) + 1);
    }
    void operator=(const string &s) {
      clear();
      resize(s.size());
      memcpy(&v[0], &s[0], num);
    }
    void operator=(const char *s) {
      clear();
      resize(strlen(s) + 1);
      memcpy(&v[0], s, num);
    }
  }; // end class string

} // end namespace type


/*===================================================================
^`F
OԂ̊OɏoĎQƂ₷Ă
===================================================================*/
typedef type::decl<char> tchar;
typedef type::decl<short> tshort;
typedef type::decl<int> tint;
typedef type::decl<long> tlong;
typedef type::decl<float> tfloat;
typedef type::decl<double> tdouble;
typedef type::decl<long long> tllong;
typedef type::decl<unsigned char> tuchar;
typedef type::decl<unsigned short> tushort;
typedef type::decl<unsigned int> tuint;
typedef type::decl<unsigned long> tulong;
typedef type::decl<unsigned long long> tullong;



/*===================================================================
OԍĊJ
===================================================================*/
namespace type {


  /*=================================================================
  ozlistF
  vfǉۂɌ^w肷邱ƂŕʁX̌^Xgɂł
  =================================================================*/
  class list : public mem_base {
        
    

  protected:
        
    
    /*---------------------------------------------------------------
    list\ŏvf
    ---------------------------------------------------------------*/
    class cell_base : public mem_base {
    public:
      cell_base *next;
      cell_base *prev;
      cell_base() : next(NULL), prev(NULL), mem_base() {}
    }; // end class cell
    

    /*---------------------------------------------------------------
    list̃f[^
    ---------------------------------------------------------------*/
    template <class U> class cell final : public cell_base {
    public:
      U data;
      cell() : cell_base(){}
    };
    
    /*
    Xg̐[
    */
    mem<cell<tchar> > head;


  public:


    /*---------------------------------------------------------------
    RXgN^
    ---------------------------------------------------------------*/
    list() : mem_base(), head(mem<cell<tchar> >())
    {
      // zXg쐬
      head.get().prev = head.get().next = 
        &static_cast<cell_base&>(head.get());
    }
    

    /*---------------------------------------------------------------
    [push
    ---------------------------------------------------------------*/
    template<class U> void push(const U &n) {
      cell<U> *c = new cell<U>;
      c->data = n;
      c->prev = head.get().prev;
      c->next = &static_cast<cell_base&>(head.get());
      c->next->prev = c->prev->next = c;
    }
    
    

    /*---------------------------------------------------------------
    wʒupop
    head = head->prev; pop(head->next);
    ---------------------------------------------------------------*/
    void pop(cell_base *p) {
      p->prev->next = p->next;
      p->next->prev = p->prev;
      delete p;
    }
    

    /*---------------------------------------------------------------
    Xg̐擪Ԃ
    ---------------------------------------------------------------*/
    const cell_base *begin() const { return &(cell_base&)head.get(); }
    cell_base *begin() { return &(cell_base&)head.get(); }
    
    

    /*---------------------------------------------------------------
    fXgN^
    ---------------------------------------------------------------*/
    ~list(){
      auto a = begin();
      while(a != a->next) {
        pop(a->next);
      }
    }

 
    /*---------------------------------------------------------------
    l擾
    ---------------------------------------------------------------*/
    template<class U> void get(
      const type::list::cell_base *p,
      U &t
    ){
      /*
      constOă_ELXg|C^Ӓl֊i[
      */
      type::list::cell<U> *a = 
        static_cast<type::list::cell<U>*>(
          const_cast<type::list::cell_base*>(
            p
          )
        );
      t = a->data;
    }


  }; // end class list


} // end namespace type




#endif
